forge.typo3.org - Bug #49877
Feature # 36172 (Closed): Forge cleanup and update umbrella issue
Feature # 45844 (Closed): Separate SVN from the Redmine server
SVN authorization
2013-07-11 09:03 - Steffen Gebert

Status: Closed Start date: 2013-07-11
Priority: Must have Due date:

Assignee: Steffen Gebert % Done: 70%
Category: Estimated time: 0.00 hour
Target version:

Description
When a user commits to an SVN repository, it has to be checked, whether he's allowed to do so.

e Authentication (asking for username + password) is already through done (using the /services/authenticate.php)
¢ Authorization then has to check, if the user belongs to the group having write permission for this path.

This is not fixed, yet. We see two options:
1. pull (through a cron job or triggered by MQ) a list of all projects from forge and loop over them to ask for the project

memberships.
Then put these data together to an "authz path-based authorization" file that looks like this:

[groups]

admins = john, inge, dieter

extension-gimmefive-developers = jocrau, ohader

extension-contentparser-developers = jocrau

extension-rootline-developers = jocrau

extension-perfectlightbox-developers = niediek

extension-nc_staticfilecache-developers = sonne, ohader, danp, franzripfel, stefan_sprenger,

xeljung0l, soda_2005, ncfrans, michael.klapper, spyker, fablen

[/gimmefive]
@extension-gimmefive-developers = rw

[/contentparser]
@extension—-contentparser-developers = rw

[/]

@admins = rw
@extensions—-developers = rw
* =r

2. bring back the old code to redmine that writes the authz file (this and probably few others) and expose this file to the SVN
server, which fetches it regulary. | suggest to be careful when doing so and first downloading it and then moving the
downloaded file (after a size verification?) over the active one (atomic operation).

a

History

#1 - 2013-07-11 09:04 - Steffen Gebert

It sounded like we will try 1. first and Bastian offered his help there

#2 - 2013-07-12 22:51 - Steffen Gebert
- File svn-groups.php added

Attached is a possible solution.
Caveat: it relies on the typo3_api plugin | wrote some time ago, which seems not to work in Redmine 2.2 (see redmine forum entry). The problem

exposes the user's login name to the API. If we don't get a hint, how this works now (I think | will ask Stefan about that), we would have to patch the
view in redmine).
http://www.redmine.org/projects/redmine/wiki/Rest_Projects#Listing-projects
http://www.redmine.org/projects/redmine/wiki/Rest_Memberships#GET
http://www.redmine.org/projects/redmine/wiki/Rest_Memberships#GET
https://github.com/TYPO3/redmine/commit/be38c63faa9fd6a9b173d1deb8025a5d3f0edc91
https://github.com/TYPO3/rm_typo3_api/blob/master/app/views/members/index.api.rsb
http://www.redmine.org/boards/2/topics/38121

#3 - 2013-07-12 22:54 - Steffen Gebert
- Status changed from New to Needs Feedback

- % Done changed from 0 to 70

#4 - 2013-07-13 16:33 - Steffen Gebert

- Assignee set to Steffen Gebert

#5 - 2017-02-03 20:13 - Steffen Gebert
- Status changed from Needs Feedback to Rejected

#6 - 2017-04-29 17:21 - Steffen Gebert

- Status changed from Rejected to Closed

Files
svn-groups.php 5.83 KB 2013-07-12 Steffen Gebert
